#if !defined(__CHYDRODATA_H__)
#define __CHYDRODATA_H__

#include "IHydro.h"
#include <vector>
#include "CExperimentalPointData.h"
#include "TNT.h"

class CHydroData: public IHydro{
	friend class CHydroManager;
public:
	CHydroData(enum hydroCst::modelHydro modelHydro, enum hydroCst::modelEmulsion modelEmulsion, double criticalWC, double ronningsenTemp, double palAndRhodesCst, const TNT::Array1D<CExperimentalPointData*>& expPoints, double tau0, double x);
	~CHydroData();
	CHydroData(const CHydroData& hydro);

	enum hydroCst::modelHydro get_hydroModel() const;
	enum hydroCst::modelEmulsion get_emulsionModel() const;

	void set_hydroModel(enum hydroCst::modelHydro aHydroModel);
	void set_emulsionModel(enum hydroCst::modelEmulsion aModelEmulsion);

	double get_criticalWC() const;
	double get_ronningsenTemp() const;
	double get_palAndRhodesCst() const;

	void set_criticalWC(double wc);
	void set_ronningsenTemp(double ronningsenTemp);
	void set_palAndRhodesCst(double palNRhodesCst);

	unsigned int get_nbExpPoints() const;
	CExperimentalPointData* get_experimentPoint(unsigned int wantedPoint);


	double get_tau0() const;
	double get_x() const;

	void set_tau0(double tau0);
	void set_x(double x);

protected:
	enum hydroCst::modelHydro m_modelHydro;
	enum hydroCst::modelEmulsion m_modelEmulsion;

	double m_criticalWC;
	double m_ronningsenTemp;
	double m_palAndRhodesCst;

	std::vector<CExperimentalPointData*> m_expPoints;

	double m_tau0;
	double m_x;
};



#endif //__CHYDRODATA_H__
