#include "CCapeBadInvOrder.h"

namespace R2PException{
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CCapeBadInvOrder::CCapeBadInvOrder(HRESULT hr, const std::wstring& desc): CCapeComputation(hr, desc){
	_requestedOperation = L"";
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CCapeBadInvOrder::CCapeBadInvOrder(IDispatch* pDisp): CCapeComputation(pDisp){
	ECapeBadInvOrder* pCape = NULL;
	HRESULT hres = pDisp->QueryInterface(IID_ECapeBadInvOrder, (void**)&pCape);
	if(FAILED(hres)){
		_description += L"WARNING: Cannot access ECapeBadInvOrder error interface from a third CAPE_OPEN component: attributes are undefined.\n";
		_requestedOperation = L"";
	}
	else{
		BSTR bstr_requestedOperation = NULL;
		pCape->get_requestedOperation(&bstr_requestedOperation);
		if(SUCCEEDED(hres) && bstr_requestedOperation != NULL)
			_requestedOperation = bstr_requestedOperation;
		else{
			_description += L"WARNING: Failed while getting requestedOperation: value is undefined.\n";
			_requestedOperation = L"";
		}
		::SysFreeString(bstr_requestedOperation);
	}
	if(pCape) pCape->Release();
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CCapeBadInvOrder::~CCapeBadInvOrder(){
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
void CCapeBadInvOrder::set_requestedOperation(const std::wstring& ReqOp){
	_requestedOperation = ReqOp;
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
void CCapeBadInvOrder::get_requestedOperation(std::wstring& ReqOp){
	ReqOp = _requestedOperation;
}
} //End namespace R2PException
