#include "CCapeBoundaries.h"

namespace R2PException{
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CCapeBoundaries::CCapeBoundaries(){
	_lowerBound = 0.;
	_upperBound = 0.;
	_value = 0.;
	_type = L"";
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CCapeBoundaries::CCapeBoundaries(IDispatch* pDisp){
	ECapeBoundaries* pCape = NULL;
	_lowerBound = 0.;
	_upperBound = 0.;
	_value = 0.;
	_type = L"";
	
	HRESULT hr = pDisp->QueryInterface(IID_ECapeBoundaries, (void**)&pCape);
	if(SUCCEEDED(hr)){
		BSTR bstrtype = NULL;
		pCape->get_LowerBound(&_lowerBound);
		pCape->get_UpperBound(&_upperBound);
		pCape->get_value(&_value);
		hr = pCape->get_Type(&bstrtype);
		_type = (SUCCEEDED(hr) && bstrtype != NULL)? bstrtype: L"";
		::SysFreeString(bstrtype);
	}
	if(pCape) pCape->Release();
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CCapeBoundaries::~CCapeBoundaries(){
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
void CCapeBoundaries::set_boundaries(double lbound, double ubound, double value, const std::wstring& type){
	_lowerBound = lbound;
	_upperBound = ubound;
	_value = value;
	_type = type;
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
void CCapeBoundaries::get_LowerBound(double& lbound){
	lbound = _lowerBound;
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
void CCapeBoundaries::get_UpperBound(double& ubound){
	ubound = _upperBound;
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
void CCapeBoundaries::get_value(double& value){
	value = _value;
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
void CCapeBoundaries::get_Type(std::wstring& type){
	type = _type;
}


} //End namespace R2PException
