// CCapeInvalidArgument.h: interface for the ECapeInvalidArgument class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPEINVALIDARGUMENT_H__)
#define __CCAPEINVALIDARGUMENT_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeBadArgument.h"
#include "stdafx.h"

namespace R2PException{
	/// <summary>Exception handling class: An invalid argument value was passed. For instance the passed name of the phase does not belong to the CO Phase List</summary> 
	class CCapeInvalidArgument: public CCapeBadArgument
	{
	public:
		/// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapeInvalidArgument(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapeInvalidArgument object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapeInvalidArgument interface</param>
		CCapeInvalidArgument(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		~CCapeInvalidArgument();
	};
}
#endif // __CCAPEINVALIDARGUMENT_H__
