// CCapePersistenceOverflow.h: interface for the ECapePersistenceOverflow class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPEPERSISTENCEOVERFLOW_H__)
#define __CCAPEPERSISTENCEOVERFLOW_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapePersistence.h"
#include "CCapeBoundaries.h"

namespace R2PException{
	/// <summary>Exception handling class: There is an overflow of internal persistence system</summary> 
	class CCapePersistenceOverflow: public CCapePersistence, public CCapeBoundaries
	{
	public:
		/// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapePersistenceOverflow(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapePersistenceOverflow object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapePersistenceOverflow interface</param>
		/// <param name="hr">CO error code</param>
		CCapePersistenceOverflow(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		~CCapePersistenceOverflow();

	};
}
#endif // __CCAPEPERSISTENCEOVERFLOW_H__
