// CCapeComputation.h: interface for the ECapeComputation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPECOMPUTATION_H__)
#define __CCAPECOMPUTATION_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeUser.h"
#include "stdafx.h"

namespace R2PException{
	/// <summary>Exception handling class: The base class of the errors hierarchy related to the calculation</summary> 
	class CCapeComputation: public CCapeUser
	{
	public:
		//// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapeComputation(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapeComputation object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapeComputation interface</param>
		CCapeComputation(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		virtual ~CCapeComputation();

	};
}
#endif // __CCAPECOMPUTATION_H__
