// CBadParamteter.h: interface for the ECapeBadCOParameter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPEDATA_H__)
#define __CCAPEDATA_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeUser.h"
#include "stdafx.h"

namespace R2PException{
	/// <summary>Exception handling class: The base class of the errors hierarchy related to any data. The data are the arguments of operations, the parameters coming from the Parameter Common Interface and information on licence key</summary> 
	class CCapeData: public CCapeUser
	{
	public:
		//// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapeData(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapeData object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapeData interface</param>
		CCapeData(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		virtual ~CCapeData();

	};
}
#endif // __CCAPEDATA_H__
