#include "CCapeError.h"
#include "CCOMUtils.h"


/****************************************************************************************************************************
*  Constructor/Destructor
*
****************************************************************************************************************************/
CCapeError::CCapeError(){
	CCOMUtils::loadCOM();
	mCOError = NULL;
}
/****************************************************************************************************************************
*
*
****************************************************************************************************************************/
CCapeError::~CCapeError(){
	CoUninitialize();
	if(mCOError){
		delete mCOError;
		mCOError = NULL;
	}
}
/****************************************************************************************************************************
*								GESTION DES ERREURS
*
****************************************************************************************************************************/
STDMETHODIMP CCapeError::get_code(long* code){
	if (mCOError != NULL)
		mCOError->get_legacyCode(*code);
	return S_OK;
}
/****************************************************************************************************************************
*
*
****************************************************************************************************************************/
STDMETHODIMP CCapeError::get_description(BSTR* description){
	std::wstring wsTmp = L"";
	if (mCOError != NULL)
		mCOError->get_description(wsTmp);

	*description = ::SysAllocString(wsTmp.c_str());
	return S_OK;
}
/****************************************************************************************************************************
*
*
****************************************************************************************************************************/
STDMETHODIMP CCapeError::get_scope(BSTR* scope){
	std::wstring wsTmp = L"";
	if (mCOError != NULL)
		mCOError->get_scope(wsTmp);

	*scope = ::SysAllocString(wsTmp.c_str());
	return S_OK;
}
/****************************************************************************************************************************
*
*
****************************************************************************************************************************/
STDMETHODIMP CCapeError::get_interfaceName(BSTR* interfaceName){
	std::wstring wsTmp = L"";
	if (mCOError != NULL)
		mCOError->get_interfaceName(wsTmp);

	*interfaceName = ::SysAllocString(wsTmp.c_str());
	return S_OK;
}
/****************************************************************************************************************************
*
*
****************************************************************************************************************************/                             
STDMETHODIMP CCapeError::get_operation(BSTR	* operation){
	std::wstring wsTmp = L"";
	if (mCOError != NULL)
		mCOError->get_operation(wsTmp);

	*operation = ::SysAllocString(wsTmp.c_str());
	return S_OK;
}
/****************************************************************************************************************************
*
*
****************************************************************************************************************************/
STDMETHODIMP CCapeError::get_moreInfo(BSTR* moreInfo){
	std::wstring wsTmp = L"";
	if (mCOError != NULL)
		mCOError->get_moreInfo(wsTmp);

	*moreInfo = ::SysAllocString(wsTmp.c_str());
	return S_OK;
}
/****************************************************************************************************************************
*
*
****************************************************************************************************************************/
STDMETHODIMP CCapeError::get_name(BSTR* name){
	std::wstring wsTmp = L"";
	if (mCOError != NULL)
		mCOError->get_name(wsTmp);

	*name = ::SysAllocString(wsTmp.c_str());
	return S_OK;
}
/****************************************************************************************************************************
*
*
****************************************************************************************************************************/
STDMETHODIMP CCapeError::get_position(short* pos){
	if (mCOError != NULL)
		mCOError->get_position(*pos);

	return S_OK;
}
/****************************************************************************************************************************
*	ECapeBadCOParameter
*
****************************************************************************************************************************/                               
STDMETHODIMP CCapeError::get_parameterName(BSTR* parametername){
	std::wstring wsTmp = L"";
	if (mCOError != NULL)
		mCOError->get_parameterName(wsTmp);
	*parametername = ::SysAllocString(wsTmp.c_str());
	return S_OK;
}
/****************************************************************************************************************************
*
*
****************************************************************************************************************************/                               
STDMETHODIMP CCapeError::get_parameter(IDispatch** parameter){
	if (mCOError != NULL)
		mCOError->get_parameter(parameter);
	return S_OK;
}
/****************************************************************************************************************************
*	ECapeBadInvOrder
*
****************************************************************************************************************************/                               
STDMETHODIMP CCapeError::get_requestedOperation(BSTR* requestedOperation){
	std::wstring wsTmp = L"";
	if (mCOError != NULL)
		mCOError->get_requestedOperation(wsTmp);
	*requestedOperation = ::SysAllocString(wsTmp.c_str());
	return S_OK;
}
/****************************************************************************************************************************
*	ECapeBoundaries
*
****************************************************************************************************************************/                               
STDMETHODIMP CCapeError::get_LowerBound(double* LowerBound){
	if (mCOError != NULL)
		mCOError->get_LowerBound(*LowerBound);
	return S_OK;
}
/****************************************************************************************************************************
*
*
****************************************************************************************************************************/                               
STDMETHODIMP CCapeError::get_UpperBound(double* UpperBound){
	if (mCOError != NULL)
		mCOError->get_UpperBound(*UpperBound);
	return S_OK;
}
/****************************************************************************************************************************
*
*
****************************************************************************************************************************/                               
STDMETHODIMP CCapeError::get_value(double* value){
	if (mCOError != NULL)
		mCOError->get_value(*value);
	return S_OK;
}
/****************************************************************************************************************************
*
*
****************************************************************************************************************************/
STDMETHODIMP CCapeError::get_Type(BSTR* Type){
	std::wstring wsTmp = L"";
	if (mCOError != NULL)
		mCOError->get_Type(wsTmp);
	*Type = ::SysAllocString(wsTmp.c_str());
	return S_OK;
}
