// CCapeFailedInitialisation.h: interface for the ECapeFailedInitialisation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPEFAILEDINITIALISATION_H__)
#define __CCAPEFAILEDINITIALISATION_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeComputation.h"
#include "stdafx.h"

namespace R2PException{
	/// <summary>Exception handling class: The pre-requisites are not valid. The necessary initialisation has not been performed or has failed</summary> 
	class CCapeFailedInitialisation: public CCapeComputation
	{
	public:
		/// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapeFailedInitialisation(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapeFailedInitialisation object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapeFailedInitialisation interface</param>
		CCapeFailedInitialisation(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		~CCapeFailedInitialisation();

	};
}
#endif // __CCAPEFAILEDINITIALISATION_H__
