// CCapeNoMemory.h: interface for the ECapeNoMemory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPENOMEMORY_H__)
#define __CCAPENOMEMORY_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeOutOfResources.h"
#include "stdafx.h"

namespace R2PException{
	/// <summary>Exception handling class: The physical memory necessary to the execution of the operation is out of limit</summary> 
	class CCapeNoMemory: public CCapeOutOfResources
	{
	public:
		/// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapeNoMemory(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapeNoMemory object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapeNoMemory interface</param>
		CCapeNoMemory(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		~CCapeNoMemory();

	};
}
#endif // __CCAPENOMEMORY_H__
