#include "CCapePersistenceNotFound.h"

namespace R2PException{
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CCapePersistenceNotFound::CCapePersistenceNotFound(HRESULT hr, const std::wstring& desc): CCapePersistence(hr, desc){
	_itemName = L"";
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CCapePersistenceNotFound::CCapePersistenceNotFound(IDispatch* pDisp): CCapePersistence(pDisp){
	ECapePersistenceNotFound* pCape = NULL;
	HRESULT hres = pDisp->QueryInterface(IID_ECapePersistenceNotFound, (void**)&pCape);
	if(FAILED(hres)){
		_itemName = L"";
		_description += L"WARNING: Cannot access ECapePersistenceNotFound error interface from a third CAPE_OPEN component: itemName is undefined.\n";
	}
	else{
		BSTR bstritemname = NULL;
		hres = pCape->get_itemName(&bstritemname);
		if(FAILED(hres) || bstritemname == NULL){
			_description += L"WARNING: Failed while getting itemName: value is undefined.\n";
			_itemName = L"";
		}
		else
			_itemName = bstritemname;
		::SysFreeString(bstritemname);
	}
	if(pCape) pCape->Release();
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CCapePersistenceNotFound::~CCapePersistenceNotFound(){
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
void CCapePersistenceNotFound::set_itemName(const std::wstring& iName){
	_itemName = iName;
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
void CCapePersistenceNotFound::get_itemName(std::wstring& iName){
	iName = _itemName;
}

} //End namespace R2PException
