// CCapeException.h: interface for the CCapeException class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CMOCKWARNING_H__)
#define __CMOCKWARNING_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <comdef.h>
#include <string>
#include <list>
#include "CWarning.h"
#include "CMyException.h"

namespace R2PException{
	// ======================================================================================
	/// <summary>Mock Warning class manager.</summary> 
	class CMockWarning: public CWarning{
	public:

#if 0
		/// <summary>Constructor</summary>
		/// <remarks>Do nothing</remarks>
		CMockWarning(){_lstWarn = NULL;}

		/// <summary>Destructor</summary>
		/// <remarks>Do nothing</remarks>
		~CMockWarning(){}
#endif

		/// <summary>Add a warning to the list</summary>
		/// <param name="name">A Short description of the warning</param>
		/// <param name="desc">Description of the warning</param>
		/// <param name="interfaceName">The name of the interface where the warning is thrown</param>
		/// <param name="userOperation">The name of the operation where the warning is thrown</param>
		/// <param name="hr">Warning code</param>
		/// <remarks>Do nothing</remarks>
		/// <returns>void</returns>
		void AddWarning(const std::wstring& name, const std::wstring& desc, const std::wstring& interfaceName, const std::wstring& userOperation, HRESULT hr = 0){}

		/// <summary>Add a warning to the list</summary>
		/// <param name="pWarn">A Warning</param>
		/// <returns>void</returns>
		/// <remarks>Do nothing</remarks>
		void AddWarning(CCapeWarning* pWarn){}

		/// <summary>Add a warning to the list from exception</summary>
		/// <param name="pErr">error to convert into warning</param>
		/// <Remarks>Do nothing</remarks>
		/// <returns>void</returns>
		/// <remarks>Do nothing</remarks>
		void AddWarning(CMyException& herr){}

#if 0
		/// <summary>Get top warning of the list</summary>
		/// <returns>CCapeUser: pointer to a class object which is filled with useful information</returns>
		/// <remarks>Do nothing</remarks>
		CCapeWarning* RetrieveOne(){return NULL;}

		/// <summary>Get all warnings</summary>
		/// <returns>list of CCapeUser: pointer to a list of class object, all filled with useful information</returns>
		/// <remarks>Do nothing</remarks>
		std::list<CCapeWarning*>* RetrieveAll(){return NULL;}

		/// <summary>Count the number of warnings</summary>
		/// <returns>unsinged int: the number of warning</returns>
		size_t Count(){return 0;}
#endif
	};
}
#endif // __CMOCKWARNING_H__
