#if !defined(__HYDROCONSTANTS_H__)
#define __HYDROCONSTANTS_H__

#include <string>

namespace hydroCst{

	enum modelEmulsion{
		AVERAGE = 0,
		MAXIMUM,
		CONTINUE,
		PALANDRHODES,
		RONNINGSEN,
		EXPERIMENTAL,
		NO_EMULSION_DEFINED
	};

	enum modelHydro{
		COMP = 0,
		SYNT,
		SIMP,
		OLGA2P,
		OLGA3P,
		HYSI_IFP,
		HYSI_OLGA,
		NO_MODEL
	};

	inline std::wstring hydroID2str(enum modelHydro hydroID){
		std::wstring val;
		switch(hydroID){
			case COMP:
				val = L"COMP";
				break;
			case SYNT:
				val = L"SYNT";
				break;
			case SIMP:
				val = L"SIMP";
				break;
			case OLGA2P:
				val = L"OLGA2P";
				break;
			case OLGA3P:
				val = L"OLGA3P";
				break;
			case HYSI_IFP:
				val = L"HYSIFLOW IFP MODEL";
				break;
			case HYSI_OLGA:
				val = L"HYSIFLOW OLGA 2P MODEL";
				break;
			default:
				val = L"NO MODEL";
		}
		return val;
	}
	inline std::wstring emulsionID2str(enum modelEmulsion emulsionID){
		std::wstring val;
		switch(emulsionID){
			case AVERAGE:
				val = L"AVERAGE";
				break;
			case MAXIMUM:
				val = L"MAXIMUM";
				break;
			case CONTINUE:
				val = L"CONTINUE";
				break;
			case PALANDRHODES:
				val = L"PALANDRHODES";
				break;
			case RONNINGSEN:
				val = L"RONNINGSEN";
				break;
			case EXPERIMENTAL:
				val = L"EXPERIMENTAL";
				break;
			default:
				val = L"NO MODEL";
		}
		return val;
	}

};

#endif //__HYDROCONSTANTS_H__
