// HydroServer_IFP.h: dclaration de CHydroServer_IFP


#pragma warning (disable :4204)
#include "CCapeError.h"

#pragma once
#include "resource.h"       // symboles principaux
#include <string>

#include "HydroServer_i.h"
#import	"CAPE-OPENv1-1-0.tlb"		raw_interfaces_only, raw_native_types, no_namespace, named_guids


#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Les objets COM monothread ne sont pas correctement pris en charge par les plateformes Windows CE, notamment les plateformes Windows Mobile qui ne prennent pas totalement en charge DCOM. Dfinissez _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA pour forcer ATL  prendre en charge la cration d'objets COM monothread et permettre l'utilisation de leurs implmentations. Le modle de thread de votre fichier rgs a t dfini sur 'Libre', car il s'agit du seul modle de thread pris en charge par les plateformes Windows CE non-DCOM."
#endif


#include "CSimpleHydro.h"
#include "TNT.h"



// CHydroServer_IFP

class ATL_NO_VTABLE CHydroServer_IFP :
	public CCapeError,
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CHydroServer_IFP, &CLSID_HydroServer_IFP>,
	public ISupportErrorInfo,
	public IDispatchImpl<ICapeIdentification, &IID_ICapeIdentification, &LIBID_CAPEOPEN110, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	//public IDispatchImpl<ICapeHydroContext, &IID_ICapeHydroContext, &LIBID_HydroServerLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	//public IDispatchImpl<ICapeHydroPackageManager, &IID_ICapeHydroPackageManager, &LIBID_HydroServerLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IDispatchImpl<ICapeHydroFlowRoutine, &IID_ICapeHydroFlowRoutine, &LIBID_HydroServerLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IDispatchImpl<ICapeHydroPropertyRoutine, &IID_ICapeHydroPropertyRoutine, &LIBID_HydroServerLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IDispatchImpl<ICapeHydroFields, &IID_ICapeHydroFields, &LIBID_HydroServerLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IDispatchImpl<ICapeHydroFlow, &IID_ICapeHydroFlow, &LIBID_HydroServerLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IDispatchImpl<IPersistStream, &IID_IPersistStream, &LIBID_HydroServerLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IDispatchImpl<ICapeHydroPhases, &IID_ICapeHydroPhases, &LIBID_HydroServerLib, /*wMajor =*/ 1, /*wMinor =*/ 0>

{
public:
	CHydroServer_IFP();
//	CHydroServer_IFP(const wchar_t* name, const wchar_t* desc);
	~CHydroServer_IFP();
	
DECLARE_REGISTRY_RESOURCEID(IDR_HYDROSERVER_IFP)


BEGIN_COM_MAP(CHydroServer_IFP)
	COM_INTERFACE_ENTRY(ICapeIdentification)
	//COM_INTERFACE_ENTRY(ICapeHydroContext)
	//COM_INTERFACE_ENTRY(ICapeHydroPackageManager)
	COM_INTERFACE_ENTRY(ICapeHydroPhases)
	COM_INTERFACE_ENTRY(ICapeHydroFlowRoutine)
	COM_INTERFACE_ENTRY(ICapeHydroPropertyRoutine)
	COM_INTERFACE_ENTRY(ICapeHydroFields)
	COM_INTERFACE_ENTRY(ICapeHydroFlow)
	COM_INTERFACE_ENTRY(IPersistStream)				// PERSISTANCE COM
	COM_INTERFACE_ENTRY(ECapeUser)
	COM_INTERFACE_ENTRY(ECapeData)					//no method for implementation
	COM_INTERFACE_ENTRY(ECapeRoot)
	COM_INTERFACE_ENTRY(ECapeUnknown)				//no method for implementation
	COM_INTERFACE_ENTRY(ECapeInvalidArgument)			//no method for implementation
	COM_INTERFACE_ENTRY(ECapeBadArgument)
//	COM_INTERFACE_ENTRY(ECapeSolvingError)
	COM_INTERFACE_ENTRY(ECapeOutOfBounds)				//no method for implementation
	COM_INTERFACE_ENTRY(ECapeBoundaries)
	COM_INTERFACE_ENTRY(ECapeFailedInitialisation)	//no method for implementation
//	COM_INTERFACE_ENTRY(ECapeLimitedImpl)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY2(IDispatch, ICapeIdentification) 
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

	//ICapeIdentification
	STDMETHOD(get_ComponentDescription) (/*[out, retval]*/ BSTR* description);
	STDMETHOD(put_ComponentDescription) (/*[in]*/ BSTR description);
	STDMETHOD(get_ComponentName)		(/*[out, retval]*/ BSTR* name);
	STDMETHOD(put_ComponentName)		(/*[in]*/ BSTR name);

	//IPersistStream
	STDMETHOD(IsDirty)					();
	STDMETHOD(GetClassID)				(/*[out]*/ GUID *pClassID);
	STDMETHOD(Load)						(/*[in]*/IStream * pstm);
	STDMETHOD(Save)						(/*[in]*/IStream * pstm, BOOL fClearDirty);
	STDMETHOD(GetSizeMax)				(_ULARGE_INTEGER * pcbSize);

	
	// ICapeHydroContext
	// -----------------
	/// <summary>Allows the client of a component (Unit Operation) that implements this interface to pass an ICapeHydroFlow interface to the component, so that it can access to the properties of a HPM.</summary>
	/// <param name="hpminterface">The HPM interface</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	//STDMETHOD(SetHPM)					(/*[in]*/ IDispatch* hpminterface);

	//ICapeHydroPackageManager
	/// <summary>Retrieves the names of the HPM Packages being managed by a HPM Manager component.</summary>
	/// <param name="hpmPackages">The HPM interface. If no packages are managed, UNDEFINED should be returned</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	//STDMETHOD(GetHPMPackageList)		(/*[out]*/ VARIANT *hpmPackages);

	/// <summary>Creates a new instance of a HPM Package with the configuration specified by the HPMName argument.</summary>
	/// <param name="HPMName">The name of one of the HPM Packages managed by the HPM Package Manager component</param>
	/// <param name="HPMPackage">The ICapeHydroFlow interface of the named HPM Package.</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown,ECapeFailedInitialisation</exception>
	//STDMETHOD(GetHPMPackage)			(/*[in]*/ BSTR HPMName, /*[out]*/IDispatch **HPMPackage);
	
	// ICapeHydroPhases
	// ----------------
	/// <summary>Returns the number of supported phases.</summary>
	/// <param name="num">The number of Phases supported. Depending of the return value, the interface is considered as a all Phases or a restricted Phases HPM (see below).</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	STDMETHOD(GetNumPhases)				(/*[out]*/ LONG* num);

	/// <summary>Return the Phase description.</summary>
	/// <param name="numPhase">A Phase ID. The numPhase value must be in the range 0..GetNumPhases (see below)</param>
	/// <param name="stateOfAggregation">The state of aggregation for the corresponding Phase ID.</param>
	/// <param name="typeInfo">The type information if the state of aggregation value is "Liquid" or "Solid".</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown,ECapeOutOfBounds  </exception>
	STDMETHOD(GetPhaseInfo)				(/*[in]*/ LONG numPhase, /*[out]*/BSTR* stateOfAggregation, /*[out]*/BSTR* typeInfo);

	//ICapeHydroFlowRoutine
	/// <summary>The Calculate method is used to compute the standard hydrodynamic properties: pressure drop, phase velocities and phase holdups.</summary>
	/// <param name="specification1">First specification identifier for hydrodynamic calculation.</param>
	/// <param name="specification2">Second specification identifier for hydrodynamic calculation.</param>
	/// <param name="flowregime">Specified flow regime identifier for calculation. May be UNDEFINED if no flow regime is specified for calculation.</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown,ECapeInvalidArgument,ECapeFailedInitialistion,ECapeSolvingError</exception>
	STDMETHOD(CalcFlow)					(/*[in]*/ BSTR specification1,/*[in]*/ BSTR specification2,/*[in]*/ BSTR flowregime);

	/// <summary>Check if the HPM Package support the specified type of calculation..</summary>
	/// <param name="specification1">First specification identifier for hydrodynamic calculation.</param>
	/// <param name="specification2">Second specification identifier for hydrodynamic calculation.</param>
	/// <param name="flowregime">Specified flow regime identifier for calculation. May be UNDEFINED if no flow regime is specified for calculation.</param>
	/// <param name="isSupported">Set to True if the specifications are supported by the Package, False is not supported.</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown,ECapeInvalidArgument,ECapeFailedInitialistion,ECapeSolvingError</exception>
	STDMETHOD(CheckCalcFlowSpec)		(/*[in]*/ BSTR specification1,/*[in]*/ BSTR specification2,/*[in]*/ BSTR flowregime, /*[out]*/VARIANT_BOOL* isSupported);

	/// <summary>Get the anonymous vector resulting of the previous CalcFlow function.</summary>
	/// <param name="propvals">Anonymous vector containing the CalcFlow final state values.</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown,ECapeInvalidOPeration</exception>
	STDMETHOD(GetFinalState)			(/*[out]*/VARIANT* propvals);

	/// <summary>Set an anonymous vector to the HPM to perform a CalcFlow initialization. If the vector is empty, default values initialization will be used.</summary>
	/// <param name="propvals">Anonymous vector containing the CalcFlow initial state values.</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown, ECapeFailedInitialisation</exception>
	STDMETHOD(SetInitState)				(/*[in]*/ VARIANT propvals);

	// ICapeHydroPropertyRoutine
	// -------------------------
	/// <summary>Calculate single-phase flow properties delivered by the HPM after performing a Flow Calculation</summary>
	/// <param name="props">The list of identifiers for the single-phase properties to be calculated</param>
	/// <param name="phaseLabel">Phase label of the Phase for which the properties are to be calculated</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeSolvingError, ECapeLimitedImpl, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(CalcSingleHydroProp)		(/*[in]*/ VARIANT props,/*[in]*/ BSTR phaseLabel);

	/// <summary>Calculate two-phase flow properties delivered by the <HPM Package> after performing a Flow Calculation</summary>
	/// <param name="props">The list of identifiers for the two-phase properties to be calculated</param>
	/// <param name="phaseLabels">Phase labels of the Phases for which the properties are to be calculated</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeSolvingError, ECapeLimitedImpl, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(CalcTwoHydroProp)			(/*[in]*/ VARIANT props,/*[in]*/ VARIANT phaseLabels);

	/// <summary>Return the mixture flow property which can delivered after performing the specified Flow Calculation</summary>
	/// <param name="specification1">First specification identifier for hydrodynamic calculation</param>
	/// <param name="specification2">Second specification identifier for hydrodynamic calculation</param>
	/// <param name="props">The list of the mixture property identifiers delivered after performing calculation</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(CheckMixtureHydroPropList)	(/*[in]*/ BSTR specification1,/*[in]*/ BSTR specification2,/*[out]*/ VARIANT *props);

	/// <summary>Return the single-phase flow property which can delivered after performing the specified Flow Calculation</summary>
	/// <param name="specification1">First specification identifier for hydrodynamic calculation</param>
	/// <param name="specification2">Second specification identifier for hydrodynamic calculation</param>
	/// <param name="props">The list of the single-phase property identifiers delivered after performing calculation</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(CheckSingleHydroPropList)	(/*[in]*/ BSTR specification1,/*[in]*/ BSTR specification2,/*[out]*/ VARIANT *props);

	/// <summary>Return the two-phase flow property which can delivered after performing the specified Flow Calculation</summary>
	/// <param name="specification1">First specification identifier for hydrodynamic calculation</param>
	/// <param name="specification2">Second specification identifier for hydrodynamic calculation</param>
	/// <param name="props">TThe list of the two-phase property identifiers delivered after performing calculation</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(CheckTwoHydroPropList)	(/*[in]*/ BSTR specification1,/*[in]*/ BSTR specification2,/*[out]*/ VARIANT *props);

	/// <summary>Return the list of the needed input geometry properties for performing the specified calculation</summary>
	/// <param name="specification1">First specification identifier for hydrodynamic calculation</param>
	/// <param name="specification2">Second specification identifier for hydrodynamic calculation</param>
	/// <param name="props">The list of the geometry property identifiers necessary for performing the calculation.</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(GetGeometryPropList)		(/*[in]*/ BSTR specification1,/*[in]*/ BSTR specification2,/*[out]*/ VARIANT *props);

	/// <summary>Return the list of single-hydrodynamic property for performing the specified calculation</summary>
	/// <param name="specification1">First specification identifier for hydrodynamic calculation</param>
	/// <param name="specification2">Second specification identifier for hydrodynamic calculation</param>
	/// <param name="props">The list of the single-property identifiers from hydro specification necessary for performing the calculation</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(GetSingleHydroPropList)	(/*[in]*/ BSTR specification1,/*[in]*/ BSTR specification2,/*[out]*/ VARIANT *props);

	/// <summary>Return the list of single-phase thermodynamic property for performing the specified calculation</summary>
	/// <param name="specification1">First specification identifier for hydrodynamic calculation</param>
	/// <param name="specification2">Second specification identifier for hydrodynamic calculation</param>
	/// <param name="props">The list of the single-phase property identifiers from thermo specification necessary for performing the calculation</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(GetSinglePhasePropList)	(/*[in]*/ BSTR specification1,/*[in]*/ BSTR specification2,/*[out]*/ VARIANT *props);

	/// <summary>Return the list of two-phase thermodynamic property for performing the specified calculation</summary>
	/// <param name="specification1">First specification identifier for hydrodynamic calculation</param>
	/// <param name="specification2">Second specification identifier for hydrodynamic calculation</param>
	/// <param name="props">The list of the two-phase property identifiers from thermo specification necessary for performing the calculation</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(GetTwoPhasePropList)		(/*[in]*/ BSTR specification1,/*[in]*/ BSTR specification2,/*[out]*/ VARIANT *props);

	// ICapeHydroFields
	// ----------------
	/// <summary>Retrieves the field information for the defined layer</summary>
	/// <param name="layerLabel">A (single) Layer label. This must be one of the values return by the GetPresentLayers method</param>
	/// <param name="fieldLabel">A (single) Field label. This must be one of the values return by the GetPresentFields method</param>
	/// <param name="fieldAttribute">One of the Field attribute identifiers</param>
	/// <param name="value">The value corresponding to the Field attribute identifier</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	STDMETHOD(GetFieldInfo)				(/*[in]*/ BSTR layerLabel,/*[in]*/ BSTR fieldLabel,/*[in]*/ BSTR fieldAttribute, /*[out]*/BSTR* value);

	/// <summary>Retrieves the layer information</summary>
	/// <param name="layerLabel">A (single) Layer label. This must be one of the values return by the GetPresentLayers method</param>
	/// <param name="fieldAttribute">One of the Layer attribute identifiers</param>
	/// <param name="value">The value corresponding to the Field attribute identifier </param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	STDMETHOD(GetLayerInfo)				(/*[in]*/ BSTR layerLabel,/*[in]*/ BSTR fieldAttribute, /*[out]*/BSTR* value);

	/// <summary>Retrieves the present fields labels in the define layer</summary>
	/// <param name="layerLabel">A Layer label. This must be one of the values returned by the GetPresentLayers method</param>
	/// <param name="fieldLabels">The Field labels associated to the Layer label define</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	STDMETHOD(GetPresentFields)			(/*[in]*/ BSTR layerLabel,/*[out]*/VARIANT* fieldLabels);

	/// <summary>Retrieves the present layers labels in the current flow</summary>
	/// <param name="layerLabels">The list of Layer labels present in the flow</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	STDMETHOD(GetPresentLayers)			(/*[out]*/VARIANT* layerLabels);

	/// <summary>Retrieves the present phases labels in the defined field</summary>
	/// <param name="layerLabel">A (single) Layer label. This must be one of the values return by the GetPresentLayers method</param>
	/// <param name="fieldLabel">A (single) Field label. This must be one of the values return by the GetPresentFields method</param>
	/// <param name="phaseLabels">The list of the thermodynamic phases present in the Field</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	STDMETHOD(GetPresentPhases)			(/*[in]*/ BSTR layerLabel,/*[in]*/ BSTR fieldLabel,/*[out]*/VARIANT* phaseLabels);

	/// <summary>Retrieves single-field property value for a flow </summary>
	/// <param name="pty">The identifier of the Field property for which value is requested</param>
	/// <param name="layerLabel">A (single) Layer label. This must be one of the values return by the GetPresentLayers method</param>
	/// <param name="fieldLabel">A (single) Field label. This must be one of the values return by the GetPresentFields method</param>
	/// <param name="result">Result value containing the Field property value in SI Units</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	STDMETHOD(GetSingleFieldProp)		(/*[in]*/ BSTR pty,/*[in]*/ BSTR layerLabel,/*[in]*/ BSTR fieldLabel,/*[out]*/double* result);

	/// <summary>Retrieves single-layer property value for a flow</summary>
	/// <param name="pty">The identifier of the Layer property for which value is requested</param>
	/// <param name="layerLabel">A (single) Layer label. This must be one of the values return by the GetPresentLayers method</param>
	/// <param name="result">Result value containing the Layer property value in SI Units</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	STDMETHOD(GetSingleLayerProp)		(/*[in]*/ BSTR pty,/*[in]*/ BSTR layerLabel,/*[out]*/double* result);

	/// <summary>Retrieves single-phase in a field property value for a flow</summary>
	/// <param name="pty">The identifier of the Field property for which value is requested</param>
	/// <param name="layerLabel">A (single) Layer label. This must be one of the values return by the GetPresentLayers method</param>
	/// <param name="fieldLabel">A (single) Field label. This must be one of the values return by the GetPresentFields method</param>
	/// <param name="phaseLabel">A (single) Phase label. This must be one of the values return by the GetPresentLabels method</param>
	/// <param name="result">Result value containing the Field property value in SI Units</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	STDMETHOD(GetSinglePhaseProp)		(/*[in]*/ BSTR pty,/*[in]*/ BSTR layerLabel,/*[in]*/ BSTR fieldLabel,/*[in]*/ BSTR phaseLabel,/*[out]*/double* result);

	/// <summary>Retrieves interface layers property value for a flow</summary>
	/// <param name="pty">The identifier of the Layer property for which value is requested</param>
	/// <param name="layerLabels">List of the Layer labels. The Layer labels must be two of the identifiers returned by the GetPresentLayers method</param>
	/// <param name="result">Result value containing the interface Layer property value in SI Units</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	STDMETHOD(GetTwoLayerProp)			(/*[in]*/ BSTR pty,/*[in]*/ VARIANT layerLabels,/*[out]*/double* result);
										
	// ICapeHydroFlow
	// --------------
	/// <summary>Remove all stored property values</summary>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	STDMETHOD(ClearAllProps)			();

	/// <summary>Create a HPM Package with the same configuration as the current HPM Package</summary>
	/// <param name="hpm">The interface of the HPM Packag</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	STDMETHOD(CreateHPM)				(/*[out]*/IDispatch**hpm);

	/// <summary>Copies all the stored properties from the HPM Package to the current instance</summary>
	/// <param name="hpmSource">Source HPM from which stored properties will be copied</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeUnknown</exception>
	STDMETHOD(CopyFromHPM)				(/*[in]*/IDispatch*hpmSource);

	/// <summary>Return main flow regime and qualifier evaluated after a hydrodynamic calculation</summary>
	/// <param name="regime">The flow regime identifier resulting from the hydrodynamic calculation</param>
	/// <param name="qualifier">The flow regime qualifier describing more accurately the flow regime identifier</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeBadInvOrder, ECapeUnknown</exception>
	STDMETHOD(GetFlowRegime)			(/*[out]*/BSTR*regime,/*[out]*/BSTR* qualifier);

	/// <summary>Retrieves flow values for a mixture</summary>
	/// <param name="pty">The identifier of the property which values are requested</param>
	/// <param name="values">Result vector containing property flow value(s) in SI units</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeBadInvOrder, ECapeInvalidArgument ECapeUnknown</exception>
	STDMETHOD(GetMixtureProp)			(/*[in]*/BSTR pty,/*[out]*/VARIANT* values);

	/// <summary>Retrieves single-phase flow values for a mixture</summary>
	/// <param name="pty">The identifier of the property which values are requested</param>
	/// <param name="phaseLabel">Phase label of the phase for which the hydrodynamic property is required.</param>
	/// <param name="values">Results vector containing property flow value(s) in SI units</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeBadInvOrder, ECapeInvalidArgument ECapeUnknown</exception>
	STDMETHOD(GetSingleHydroProp)		(/*[in]*/BSTR pty,/*[in]*/BSTR phaseLabel,/*[out]*/VARIANT* values);

	/// <summary>Retrieves two-phase flow values for a mixture</summary>
	/// <param name="pty">The identifier of the property which values are requested.</param>
	/// <param name="phaseLabel">List (two values) of Phase labels for which the property is required</param>
	/// <param name="values">Results vector containing property flow value(s) in SI units</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeBadInvOrder, ECapeInvalidArgument ECapeUnknown</exception>
	STDMETHOD(GetTwoHydroProp)			(/*[in]*/BSTR pty,/*[in]*/VARIANT phaseLabel,/*[out]*/VARIANT* values);

	/// <summary>Set geometry values</summary>
	/// <param name="pty">The identifier of the geometry property which values are set</param>
	/// <param name="values">Values to set for the property</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(SetGeometryProp)			(/*[in]*/BSTR pty,/*[in]*/VARIANT values);

	/// <summary>Set flow values for a mixture</summary>
	/// <param name="pty">The identifier of the property which values are set</param>
	/// <param name="values">Values to set for the property</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(SetMixtureProp)			(/*[in]*/BSTR pty,/*[in]*/VARIANT values);

	/// <summary>Set thermodynamic values for the overall mixture</summary>
	/// <param name="pty">The identifier of the property which values are set.</param>
	/// <param name="values">Values to set for the property</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(SetOverallProp)			(/*[in]*/BSTR pty,/*[out]*/VARIANT *values);				

	/// <summary>Set hydrodynamic present phases in the flow</summary>
	/// <param name="phaseLabel">The list of Phase labels for the Phases present</param>
	/// <param name="stateOfAggregation">Array of hydrodynamic state of aggregation corresponding to each of the Phase labels</param>
	/// <param name="typeInfo">Array of  hydrodynamic type of Liquid or Solid corresponding to each of the Phase labels</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(SetPresentPhases)			(/*[in]*/VARIANT phaseLabel,/*[in]*/VARIANT stateOfAggregation,/*[in]*/VARIANT typeInfo);

	/// <summary>Set single-phase hydrodynamic property values for a mixture</summary>
	/// <param name="pty">The identifier of the property which values are set</param>
	/// <param name="phaseLabel">Phase label for which the property is set</param>
	/// <param name="values">Values to set for the property</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeFailedInitialisation, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(SetSingleHydroProp)		(/*[in]*/BSTR pty,/*[in]*/BSTR phaseLabel,/*[in]*/VARIANT values);

	/// <summary>Set single-phase thermodynamic property values for a mixture</summary>
	/// <param name="pty">The identifier of the property which values are set</param>
	/// <param name="phaseLabel">Phase label for which the property is set</param>
	/// <param name="values">Values to set for the property</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeFailedInitialisation, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(SetSinglePhaseProp)		(/*[in]*/BSTR pty,/*[in]*/BSTR phaseLabel,/*[in]*/VARIANT values);

	/// <summary>Set two-phase hydrodynamic property values for a mixture</summary>
	/// <param name="pty">The identifier of the property which values are set</param>
	/// <param name="phaseLabel">Phase label for which the property is set</param>
	/// <param name="values">Values to set for the property</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeFailedInitialisation, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(SetTwoHydroProp)			(/*[in]*/BSTR pty,/*[in]*/VARIANT phaseLabel,/*[in]*/VARIANT values);

	/// <summary>Set two-phase thermodynamic values for a mixture</summary>
	/// <param name="pty">The identifier of the property which values are set</param>
	/// <param name="phaseLabel">Phase label for which the property is set</param>
	/// <param name="values">Values to set for the property</param>
	/// <returns>CapeError</returns>
	/// <exception cref="R2PException::CMyException">Thrown on false condition: ECapeNoImpl, ECapeFailedInitialisation, ECapeInvalidArgument, ECapeUnknown</exception>
	STDMETHOD(SetTwoPhaseProp)			(/*[in]*/BSTR pty,/*[in]*/VARIANT phaseLabel,/*[in]*/VARIANT values);


protected:
	CSimpleHydro m_hydro;
	std::wstring m_strName;
    std::wstring m_strDescription;

	bool m_isReady;

	// Geometry specification
	double m_diameter;
	double m_inclination;
	double m_roughness;

	// Flow specification
	int m_nbrOfPresentPhases;
	std::map<std::wstring,EPhases> m_phaseLabels;

	// Hydro specification
	// - single-phase
	TNT::Array1D<double> m_superficialVelocities;

	// Thermo specification
	// - single-phase
	TNT::Array1D<double> m_densities;
	TNT::Array1D<double> m_viscosities;
	TNT::Array1D<double> m_heatCapacities;
	TNT::Array1D<double> m_conductivities;

	// - two-phase
	TNT::Array2D<double> m_surfaceTensions;


	TNT::Array1D<double> m_anonymous;

	IDispatch* m_HPMinterface;

	HRESULT generateException(R2PException::CMyException& herr, const std::wstring& interfaceName, const std::wstring operation) throw();

};

OBJECT_ENTRY_AUTO(__uuidof(HydroServer_IFP), CHydroServer_IFP)
