#ifndef __CONSTANTS2_H_
#define __CONSTANTS2_H_

#include <math.h>

const double Uvalue				=	4.;
const double PI					=	3.14159265358979312; 
const double TempOut			=	293.;
const double gravity			=	9.81;
const double epsilonPressure	=	1.e-9;
const double epsilonEnthalpy	=	1.e-9;

const double DBL_DEFAULT		=	123.321e6;
const double DOUBLE_INF			=	HUGE_VAL / HUGE_VAL;
const int INTEGER_INF			=	7777777;
const double PRECISION_MACHINE	=	1e-16;

#define my_wtof(x) (wcsstr(x, L"1.#IND") != NULL)? DOUBLE_INF: _wtof(x)

#define isNaN(x) ((x) != (x))

enum EPhases
{
	//WARN : if order change, you must change it also in MIN_VISCOSITIES and MIN_CONDUCTIVITY arrays!!!!!
	GAS	=	0,
	OIL,
	WATER,
	HYDRATE,
	NBPHASES,
	LIQUID = 1,
	UNINITIALIZE = INTEGER_INF
};

const double 	MIN_VISCOSITIES_GAS		= 5.e-6;
const double 	MIN_VISCOSITIES_OIL		= 5.e-5;
const double 	MIN_VISCOSITIES_WATER	= 5.e-4;
const double	MIN_VISCOSITIES[NBPHASES] = {MIN_VISCOSITIES_GAS, MIN_VISCOSITIES_OIL, MIN_VISCOSITIES_WATER};
const double 	MIN_CONDUCTIVITY_GAS	= 1.e-3;
const double 	MIN_CONDUCTIVITY_OIL	= 1.e-2;
const double 	MIN_CONDUCTIVITY_WATER	= 1.e-2;
const double	MIN_CONDUCTIVITY[NBPHASES] = {MIN_CONDUCTIVITY_GAS, MIN_CONDUCTIVITY_OIL, MIN_CONDUCTIVITY_WATER};



#endif //__CONSTANTS_H2_